import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;

public class Ehefrau extends Mensch {

    // Referenz auf ein Ehemann-Objekt
    private Ehemann meinEhemann;

    /**
     * Hier passieren zwei Dinge: Zufälliges Bewegen (diese Methode wurde
     * von "Mensch" vererbt) und die Überprüfung, ob das Ehefrau-Objekt
     * ein Ehemann-Objekt berührt, das wirklich der richtige Ehemann ist.
     */
    public void act() {
        // Zufällig bewegen (Methode ist von Mensch geerbt und dort implementiert)
        bewegeZufaellig();        

        Ehemann tmpMann = (Ehemann)getOneObjectAtOffset(0,0, Ehemann.class);
        // Freien Ehemann wählen, wenn einer gefunden wird
        if (tmpMann != null) { // nur wenn wirklich ein Ehemann-Objekt berührt wird
            if ( (tmpMann.istVerheiratet() == false) && (this.istVerheiratet() == false) ){
                meinEhemann = tmpMann;
                meinEhemann.setVerheiratet(true);
                meinEhemann.setImage("man02.png");
                this.setVerheiratet(true);
                this.setImage("woman02.png");
            }
        }

        // Wenn verheiratet, dann Ehemann kontrollieren
        if (meinEhemann != null) {
            List<Ehefrau> frauList = getWorld().getObjects(Ehefrau.class);
            for (int i=0; i<frauList.size(); i++) {
                if ( (meinEhemann.getX() == frauList.get(i).getX()) && (meinEhemann.getY() == frauList.get(i).getY()) ) {
                    if (frauList.get(i) != this) {
                        getWorld().removeObject(meinEhemann);
                        meinEhemann = null;
                        this.setVerheiratet(false);
                        return;
                    }
                }
            }
        }
    }    
}
