import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

public class Fisch extends Tier {

    private int alter;
    private int maxAlter = 10;

    public Fisch() {
        alter = 0;
    }   

    public void erzeugeNachkommenUndStirb() {
        Fisch tmp = new Fisch();
        getWorld().addObject(tmp, getX(), getY());
        tmp.bewege();
        if (!isTouching(Fisch.class)) {
            getWorld().addObject(new Fisch(), getX(), getY());
        }   
        getWorld().removeObject(this);
    }

    public void bewege()  {
        int r = Greenfoot.getRandomNumber(4);
        int x = getX();
        int y = getY();
        int dx = 0;
        int dy = 0;
        if (r == 0) {            
            dx = -1;
        }
        if (r == 1) {            
            dx = 1;
        }
        if (r == 2) {            
            dy = -1;
        }
        if (r == 3) {            
            dy = 1;
        }

        setLocation(getX()+dx, getY()+dy);

        if (getX() >= getWorld().getWidth()) {
            setLocation(0, getY());
        }
        else {
            if (getX() < 0) {
                setLocation(getWorld().getWidth()-1, getY());    
            }
        }

        if (getY() >= getWorld().getHeight()) {
            setLocation(getX(), 0);
        }
        else {
            if (getY() < 0) {
                setLocation(getX(), getWorld().getHeight()-1);    
            }
        }

        if (isTouching(Tier.class)) {
            setLocation(x, y);
        }
    }    

    public void act() {
        bewege();
        alter = alter + 1;
        if (alter > maxAlter) {
            erzeugeNachkommenUndStirb();
        }
    }    
}
