import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

public class Hai extends Tier {

    private int energie;
    private int energieFuerNachwuchs = 75;

    public Hai(int pEnergie) {
        energie = pEnergie;
    }   

    public void erzeugeNachkommen() {
        int x = getX();
        int y = getY();
        Hai tmp = new Hai(energie/2);
        getWorld().addObject(tmp, getX(), getY());
        tmp.bewege();
        energie = energie/2;
    }
    
    public void stirb() {
        getWorld().removeObject(this);
    }

    public void bewege()  {
        int r = Greenfoot.getRandomNumber(4);
        int x = getX();
        int y = getY();
        int dx = 0;
        int dy = 0;
        if (r == 0) {            
            dx = -1;
        }
        if (r == 1) {            
            dx = 1;
        }
        if (r == 2) {            
            dy = -1;
        }
        if (r == 3) {            
            dy = 1;
        }

        setLocation(getX()+dx, getY()+dy);

        if (getX() >= getWorld().getWidth()) {
            setLocation(0, getY());
        }
        else {
            if (getX() < 0) {
                setLocation(getWorld().getWidth()-1, getY());    
            }
        }

        if (getY() >= getWorld().getHeight()) {
            setLocation(getX(), 0);
        }
        else {
            if (getY() < 0) {
                setLocation(getX(), getWorld().getHeight()-1);    
            }
        }

        if (isTouching(Hai.class)) {
            setLocation(x, y);
        }
    }    

    public void act() {
        bewege();
        energie = energie - 1;
        
        if (isTouching(Fisch.class)) {
            Actor tmp = getOneObjectAtOffset(0, 0, Fisch.class);
            getWorld().removeObject(tmp);
            energie = energie + 10;
        }
        
        if (energie > energieFuerNachwuchs) {
            erzeugeNachkommen();
        }
        
        if (energie <= 0) {
            stirb();
        }
        
    }    
}
