import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.ArrayList; // Listen importieren

public class Fisch extends Tier {

    // Attribute
    private int age;
    private int BREED_TIME = 1;

    /**
     * Konstruktor
     * age wird mit 0 initialisiert
     */
    public Fisch() {
        age = 0;
    }   

    /**
     * ACT - Ablauf:
     * 
     * 1. bewegen
     * 2. wenn alt genug, dann Nachkomme erzeugen
     * 3. age erhöhen
     */
    public void act() {
        // Bewegen
        Koordinate k = getZufaelligesFreiesNachbarfeld();
        if (k != null) {
            setLocation(k.getX(), k.getY());
        }

        // ggf. Nachkommen erstellen
        if (age > BREED_TIME) {            
            Fisch f = new Fisch();
            erzeugeNachkomme(f);
        }

        // age erhöhen
        age = age + 1;
    }    
}
