import greenfoot.*;

public class Ozean extends World {

    /**
     * Konstruktor der Klasse Ozean
     */
    public Ozean() {            
        super(100, 100, 3, false); // damit es keinen Rand gibt
        Greenfoot.setSpeed(100);        
        int size = 100; // Größe der Welt in Feldern
        getBackground().setColor(Color.BLACK); // schwarzer Hintergrund

        // Erzeuge 2000 Fische auf freien Positionen
        int i = 0;
        while (i<2000) {
            //Fisch nur in freies zufälliges Feld platzieren
            int rX = Greenfoot.getRandomNumber(size);
            int rY = Greenfoot.getRandomNumber(size);
            if (getObjectsAt(rX, rY, Tier.class).size() == 0){
                addObject(new Fisch(), rX, rY);
                i++;
            }
        }
        // Erzeuge 2000 Haie auf freien Positionen
        i = 0;
        while (i<2000) {
            //Hai nur in freies zufälliges Feld platzieren
            int rX = Greenfoot.getRandomNumber(size);
            int rY = Greenfoot.getRandomNumber(size);
            if (getObjectsAt(rX, rY, Tier.class).size() == 0){
                addObject(new Hai(), rX, rY);
                i++;
            }
        }
    }

    /**
     * Die ausgegebenen Daten können für ein Diagramm z.B. in Excel kopiert werden
     * 
     * Auskommentieren, um die Anzahl der Fische und Haie auszugeben
     */
    public void act() {
        System.out.println(getObjects(Fisch.class).size() + " " + getObjects(Hai.class).size());
    }

}
